# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UserServiceRole(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'service_roles': 'list[CspgatewayamapiusersuserIdorgsorgIdservicerolesRolesToAdd]',
        'service_definition_link': 'str',
        'service_role_names': 'list[str]'
    }

    attribute_map = {
        'service_roles': 'serviceRoles',
        'service_definition_link': 'serviceDefinitionLink',
        'service_role_names': 'serviceRoleNames'
    }

    def __init__(self, service_roles=None, service_definition_link=None, service_role_names=None):  # noqa: E501
        """UserServiceRole - a model defined in Swagger"""  # noqa: E501
        self._service_roles = None
        self._service_definition_link = None
        self._service_role_names = None
        self.discriminator = None
        if service_roles is not None:
            self.service_roles = service_roles
        if service_definition_link is not None:
            self.service_definition_link = service_definition_link
        if service_role_names is not None:
            self.service_role_names = service_role_names

    @property
    def service_roles(self):
        """Gets the service_roles of this UserServiceRole.  # noqa: E501


        :return: The service_roles of this UserServiceRole.  # noqa: E501
        :rtype: list[CspgatewayamapiusersuserIdorgsorgIdservicerolesRolesToAdd]
        """
        return self._service_roles

    @service_roles.setter
    def service_roles(self, service_roles):
        """Sets the service_roles of this UserServiceRole.


        :param service_roles: The service_roles of this UserServiceRole.  # noqa: E501
        :type: list[CspgatewayamapiusersuserIdorgsorgIdservicerolesRolesToAdd]
        """

        self._service_roles = service_roles

    @property
    def service_definition_link(self):
        """Gets the service_definition_link of this UserServiceRole.  # noqa: E501


        :return: The service_definition_link of this UserServiceRole.  # noqa: E501
        :rtype: str
        """
        return self._service_definition_link

    @service_definition_link.setter
    def service_definition_link(self, service_definition_link):
        """Sets the service_definition_link of this UserServiceRole.


        :param service_definition_link: The service_definition_link of this UserServiceRole.  # noqa: E501
        :type: str
        """

        self._service_definition_link = service_definition_link

    @property
    def service_role_names(self):
        """Gets the service_role_names of this UserServiceRole.  # noqa: E501


        :return: The service_role_names of this UserServiceRole.  # noqa: E501
        :rtype: list[str]
        """
        return self._service_role_names

    @service_role_names.setter
    def service_role_names(self, service_role_names):
        """Sets the service_role_names of this UserServiceRole.


        :param service_role_names: The service_role_names of this UserServiceRole.  # noqa: E501
        :type: list[str]
        """

        self._service_role_names = service_role_names

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UserServiceRole, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserServiceRole):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
